
/** Interface définissant une structure de données qui répond à une <em>Range Minimum Query</em>.*/
public interface RMQ {

	/**
	 * Supposant que les éléments sont stoqués dans un tableau T[] de type 'Data', cette fonction renvoie l'élément de valeur
	 * minimal qui se trouve dans l'interval [l, r]. <br>
	 * On suppose que: <tt> 0<= l < =r < n <tt>.
	 * 
	 * @param l		extremité gauche de l'intervalle (l>=0)
	 * @param r		extremité droite de l'intervalle (r<n)
	 * @return 		valeur minimale dans T[l, r]
	 */
	Data getMin(int l, int r);

	/** Renvoie la taille du tableau en entrée */
	int getSize();

	/** Renvoie le tableau en entrée */
	Data[] getArray();

}
