
public class Test13 {

	public static void main(String[] args) {
		if (!Test11.class.desiredAssertionStatus()) {
			System.err.println("Vous devez activer l'option -ea de la JVM");
			System.err.println("To run the tests please activate the -ea option of the JVM");
			System.exit(1);
		}

		System.out.print("(Q1.3) Test RMQ: efficient implementation\n");

		int n = 1000;
		EfficientRMQ rmq;
		Data[] t1 = Test11.increasingArray(n);
		Data[] t2 = Test11.decreasingArray(n);
		Data[] t3 = Test11.holeArray(n);

		int[] bs = new int[] { 2, 5, 10, 20, 40, 100 };
		for (int b : bs) {
			rmq = new EfficientRMQ(t1, b);
			testRMQ(rmq);
			rmq = new EfficientRMQ(t2, b);
			testRMQ(rmq);
			rmq = new EfficientRMQ(t3, b);
			testRMQ(rmq);
		}

		// Data[] cities=Test11.largestCities();
	}

	public static void testRMQ(EfficientRMQ rmq) {
		int n = rmq.getSize();
		Data[] t = rmq.getArray();

		System.out.printf("\t n=%-4d, block size b=%-3d\t", n, rmq.b);

		Data.cnt = 0;
		// perform tests
		for (int i = 0; i < n; i++) {
			Data m = t[i];
			for (int j = i; j < n; j++) {
				m = (m.compareTo(t[j])  > 0) ? t[j] : m;
				Data testm  = rmq.getMin(i, j);
				if (testm.compareTo(m) != 0)
					throw new Error("Erreur: valeure minimale renvoyée=" + testm + ", au lieu de " + m);
			}
		}

		float naive = (float) n*n*n / 6;
		System.out.printf("\t\t [OK] [%d comparisons] [%.1f%% of brute force].\n", Data.cnt, 100 * (Data.cnt / naive));
	}

}
